| Questions |
| What platforms / compilers are being used to build the binary distribution kits? What are the differences between Xerces-C and XML4C? Which DLL's do I need to distribute with my application? How do I package the sources to create a binary drop? I do not see binaries for my platform. When will they be available? When will a port to my platform be available? How can I port Xerces to my favourite platform? What application do you use to create the documentation? Can I use Xerces in my product? How do I uninstall Xerces-C++? I am getting a tar checksum error on Solaris. What's the problem?
| What platforms / compilers are being used to build the binary distribution kits? |
| Xerces binaries has been built on the following platforms with these compilers
Operating System | Compiler
32-bit
Windows x86 | MS Visual C++ 7.1 (2003)
Windows x86 | MS Visual C++ 8.0 (2005)
Linux x86 | GCC 3.4.x or later
Solaris 10 x86 | GCC 3.4.x or later
Solaris 10 x86 | Sun C++ 5.7 (Studio 10) or later
Solaris 10 SPARC | GCC 3.4.x or later
Solaris 10 SPARC | Sun C++ 5.7 (Studio 10) or later
AIX 5.3 PowerPC | IBM XL C++ 7.0 or later
HP-UX 11i PA-RISC | HP aCC A.03.x
HP-UX 11i IA-64 | HP aCC A.06.x
MacOS X 10.4 "Tiger" x86 | GCC 4.0.x (Xcode 2.x) or later
MacOS X 10.4 "Tiger" PowerPC | GCC 4.0.x (Xcode 2.x) or later
64-bit
Windows x86-64 | MS Visual C++ 8.0 (2005)
Linux x86-64 | GCC 3.4.x or later
Solaris 10 x86-64 | GCC 3.4.x or later
Solaris 10 x86-64 | Sun C++ 5.7 (Studio 10) or later
Solaris 10 SPARC | GCC 3.4.x or later
Solaris 10 SPARC | Sun C++ 5.7 (Studio 10) or later
AIX 5.3 PowerPC | IBM XL C++ 7.0 or later
HP-UX 11i PA-RISC | HP aCC A.03.x
HP-UX 11i IA-64 | HP aCC A.06.x
| What are the differences between Xerces-C and XML4C? |
| By default Xerces-C++ has intrinsic support for ASCII, UTF-8, UTF-16 (Big/Small Endian), UCS4 (Big/Small Endian), EBCDIC code pages IBM037, IBM1047 and IBM1140 encodings, ISO-8859-1 (aka Latin1) and Windows-1252. This means that it can parse input XML files in these above mentioned encodings. However, if you wish to parse XML files in any other encodings, say in Shift-JIS, Big5 etc., then you will need to build Xerces-C++ with the International Components for Unicode (ICU) library. XML4C is simply Xerces-C++ built with ICU.
| Which DLL's do I need to distribute with my application? |
| You only need to distribute one file: xerces-c_2_8.dll for Windows, or libxerces-c28.0.a for AIX, or libxerces-c.so.28.0 for Solaris/Linux, or libxerces-c.sl.28.0 for HP-UX on PA-RISC, or libxerces-c.so.28.0 for HP-UX on IA64, or libxerces-c.28.0.dylib for Mac OS X. However, if you are using the ICU transcoder then in addition to the library file mentioned above, you also need to ship: ICU shared library file: icuuc*.dll for Windows, or libicuuc*.a for AIX, or libicuuc*.so for Solaris/Linux, or libicuuc*.sl for HP-UX on PA-RISC, or libicuuc*.so for HP-UX on IA64, or libicuuc*.dylib for Mac OS X. ICU converter data shared library file: icudt*.dll for Windows, or libicudt*.a for AIX, or libicudt*.so for Solaris/Linux, or libicudt*.sl for HP-UX on PA-RISC, or libicudt*.so for HP-UX on IA-64, or libicudt*.dylib for Mac OS X. The Xerces-C++ Message file: XercesMessages*.dll for Windows, or libXercesMessages*.a for AIX, or libXercesMessages*.so for Solaris/Linux, or libXercesMessages*.sl for HP-UX on PA-RISC, or libXercesMessages*.so for HP-UX on IA64, or libXercesMessages*.dylib for Mac OS X.
| How do I package the sources to create a binary drop? |
| You have to first compile the sources inside your IDE to create the required DLLs and EXEs. Then you need to copy over the binaries to another directory for the binary drop. A perl script has been provided to give you a jump start. You need to install perl on your machine for the script to work. If you have changed your source tree, you have to modify the script to suit your current directory structure. To invoke the script, go to the \<Xerces>\scripts directory, and type:
    perl packageBinaries.pl
You will get a message that somewhat looks like this (changes always happen, we are evolving you see!):
    Usage is: packageBinaries <options>
    options are:  -s <source_directory>
                  -o <target_directory>
                  -c <C compiler name> (e.g. gcc or xlc_r)
                  -x <C++ compiler name> (e.g. g++ or xlC_r)
                  -m <message loader> can be 'inmem', 'icu' or 'iconv'
                  -n <net accessor> can be 'fileonly' or 'libwww'
                  -t <transcoder> can be 'icu' or 'native'
                  -r <thread option> can be 'pthread' or 'dce' (only used on HP-11)
                  -h to get help on these commands
    Example: perl packageBinaries.pl -s$HOME/xerces-c-src_2_8_0
                                     -o$HOME/xerces-c_2_8_0
                                     -cgcc -xg++ -minmem
                                     -nfileonly -tnative
Make sure that your compiler can be invoked from the command line and follow the instructions to produce a binary drop.
| I do not see binaries for my platform. When will they be available? |
| The reason why you see binaries only for some specific platforms is that we have had the maximum requests for them. Moreover, we have limited resources and hence cannot publish binaries for every platform. If you wish to contribute your time and effort in building binaries for a specific platform/environment then please send a mail to the Xerces-C++ development mailing list. We can definitely use any extra help in this open source project
| When will a port to my platform be available? |
| We would like to see Xerces ported to as many platforms as there are. Again, due to limited resources we cannot do all the ports. We will help you make this port happen. Here are some Porting Guidelines. We strongly encourage you to submit the changes that are required to make it work on another platform. We will incorporate these changes in the source code base and make them available in the future releases. All porting changes may be sent to the Xerces-C++ development mailing list .
| How can I port Xerces to my favourite platform? |
| Here are some Porting Guidelines.
| What application do you use to create the documentation? |
| We have used an internal XML based application to create the documentation. The documentation files are all written in XML and the application, internally codenamed StyleBook, makes use of XSL to transform it into an HTML document that you are seeing right now. It is currently available on the Apache open source website as Cocoon. The API documentation is generated using Doxygen and GraphViz. See FAQ: Regenerating (API) documentation?
| Can I use Xerces in my product? |
| Yes! Read the license agreement first and if you still have further questions, then please address them to the Xerces-C++ user mailing list .
| How do I uninstall Xerces-C++? |
| Xerces-C++ only installs itself in a single directory and does not set any registry entries. Thus, to uninstall, you only need to remove the directory where you installed it, and all Xerces-C++ related files will be removed.
| I am getting a tar checksum error on Solaris. What's the problem? |
| The problem is caused by a limitation in the original tar spec, which prevented it from archiving files with long pathnames. Unfortunately, various current versions of tar use different extensions for eliminating this restriction which are incompatible with each other (or they do not remove the restriction at all). Rather than altering the pathnames for the Xerces-C++ package, which would make them compatible with the original tar spec but make it more difficult to know what was where, it was decided to use GNU tar (gtar), which handles arbitrarily long pathnames and is freely available on every platform on which Xerces-C++ is supported. If you don't already have GNU tar installed on your system, you can obtain it from the Free Software Foundation http://www.gnu.org/software/tar/tar.html. For additional background information on this problem, see the online manual GNU tar and POSIX tar for the utility.

Copyright © 1999-2007 The Apache Software Foundation. All Rights Reserved.